# encoding: utf-8

import os, es, gamethread, playerlib, langlib, time, urllib2

messages = langlib.Strings(es.getAddonPath("purgelog") + "/translations.ini") 

# On ajoute quelques infos à afficher lorsqu'un utilisateur tape 'es_load' dans la console
info = es.AddonInfo()
info.name = 'purgelog' # nom du script
info.version = '1.1.0' # version
info.author = 'Fantole' # auteur
info.url = 'http://mattie.info/forums/' # lien où le script peut être trouvé
info.description = 'Purger les logs du serveur' # description courte
info.tags = 'fantole,purge log,supprimer log,erase log,delete log' # mots clés


def load():
    global purgelog_path1
    global purgelog_commande1
    global purgelog_path2
    global purgelog_commande2
    global purgelog_admin
    global purgelog_autopath1
    global purgelog_autopath2
    global purgelog_auto
    global version
    
    es.ServerVar('version_purgelog', info.version, 'Version du script purgelog').makepublic()
    version = "%s" % es.ServerVar('version_purgelog')
    version = version.replace('.','')
    purgelog_path1 = es.ServerVar('purgelog_path1', 0, "purgelog : Chemin du dossier N1 log a purger")
    purgelog_commande1 = es.ServerVar('purgelog_commande1', 0, "purgelog : Commande a taper pour purger les logs N1")
    purgelog_path2 = es.ServerVar('purgelog_path2', 0, "purgelog : Chemin du dossier N2 log a purger")
    purgelog_commande2 = es.ServerVar('purgelog_commande2', 0, "purgelog : Commande a taper pour purger les logs N2")
    purgelog_admin = es.ServerVar('purgelog_admin', 0, "purgelog : Liste des Admin pouvant purger les logs")
    purgelog_autopath1 = es.ServerVar('purgelog_autopath1', 0, "purgelog : Permet de purger automatiquement les logs path1, 0 = Desactiver, 1 = Activer")
    purgelog_autopath2 = es.ServerVar('purgelog_autopath2', 0, "purgelog : Permet de purger automatiquement les logs path2, 0 = Desactiver, 1 = Activer")
    purgelog_auto = es.ServerVar('purgelog_auto', 0, "purgelog : Definit quand seront purge les logs, voir fichier de Configuration du Script")

    es.mexec('../addons/eventscripts/purgelog/cfg/config_script.cfg')

    purgelog_auto = str(purgelog_auto).split(",")

    gamethread.delayedname(1, 'crontab', crontab, (round(time.time(), 0)))    

def unload():
    gamethread.cancelDelayed('crontab')
    
def player_say(event_var):
    text = event_var['text']
    if text == str(purgelog_commande1):
        if event_var['es_steamid'] in str(purgelog_admin) and str(purgelog_path1) != "":
            EraseFile(purgelog_path1, event_var['userid'])
        else:
            joueur = playerlib.getPlayer(userid)
            es.tell(userid, '#multi', '#lightgreen[Purge log]#green %s' % messages("denied",lang=joueur.get("lang")))
        
    if text == str(purgelog_commande2):
        if event_var['es_steamid'] in str(purgelog_admin) and str(purgelog_path2) != "":
            EraseFile(purgelog_path2, event_var['userid'])
        else:
            joueur = playerlib.getPlayer(userid)
            es.tell(userid, '#multi', '#lightgreen[Purge log]#green %s' % messages("denied",lang=joueur.get("lang")))

    if text == "!purgelog":
        if event_var['es_steamid'] in str(purgelog_admin):
            check_update(event_var['userid'])

def EraseFile(repertoire,userid):
    joueur = playerlib.getPlayer(userid)
    pseudo = joueur.attributes['name']
    listejoueur = es.getUseridList()
    try:
        es.server.queuecmd('log off')
        for stockid in listejoueur:
            es.tell(stockid, '#multi', '#lightgreen[Purge log]#green %s #default%s' % (str(pseudo), messages("purgelog",lang=joueur.get("lang"))))
            
        for filename in os.listdir(es.ServerVar("eventscripts_gamedir") + "/" + repertoire):
            if ".log" in str(filename):
                os.remove(es.ServerVar("eventscripts_gamedir") + "/" + repertoire + "/" + filename)

    except Exception, err:
        print "[Purge Log] Erreur rencontrée : %s" % err
        es.tell(userid, '#multi', '#lightgreen[Purge log]#green %s' % messages("error",lang=joueur.get("lang")))
        
    else:
        es.tell(userid, '#multi', '#lightgreen[Purge log]#green %s' % messages("success",lang=joueur.get("lang")))
        es.server.queuecmd('log on')

def AutoEraseFile1():
    listejoueur = es.getUseridList()
    try:
        es.server.cmd('log off')
        for userid in listejoueur:
            joueur = playerlib.getPlayer(userid)
            es.tell(userid, '#multi', '#lightgreen[Purge log]#green %s' % messages("purgelogauto",lang=joueur.get("lang")))
            
        for filename in os.listdir(es.ServerVar("eventscripts_gamedir") + "/" + purgelog_path1):
            if ".log" in str(filename):
                os.remove(es.ServerVar("eventscripts_gamedir") + "/" + purgelog_path1 + "/" + filename)

    except Exception, err:
        print "[Purge Log1] Erreur rencontrée : %s" % err
        
    else:
        print "[Purge Log1] Purge Succes"
        es.server.cmd('log on')


def AutoEraseFile2():
    listejoueur = es.getUseridList()
    try:
        es.server.cmd('log off')
        for userid in listejoueur:
            joueur = playerlib.getPlayer(userid)
            es.tell(userid, '#multi', '#lightgreen[Purge log]#green %s' % messages("purgelogauto",lang=joueur.get("lang")))
            
        for filename in os.listdir(es.ServerVar("eventscripts_gamedir") + "/" + purgelog_path2):
            if ".log" in str(filename):
                os.remove(es.ServerVar("eventscripts_gamedir") + "/" + purgelog_path2 + "/" + filename)


    except Exception, err:
        print "[Purge Log2] Erreur rencontrée : %s" % err
        
    else:
        print "[Purge Log2] Purge Succes"
        es.server.cmd('log on')


def crontab(timestemp):
    gamethread.delayedname(1, 'crontab', crontab, (round(time.time(), 0)))
    if timestemp != round(time.time(), 0):
        if ":" not in purgelog_auto[0] and purgelog_auto[0] == time.strftime("%d"):
            if ":" in purgelog_auto[1] and purgelog_auto[1] == time.strftime("%H:%M:%S"):
                print "GO"
                if int(purgelog_autopath1) == 1 and purgelog_path1 != "":
                    AutoEraseFile1()
                if int(purgelog_autopath1) == 1 and purgelog_path1 != "":
                    AutoEraseFile2()

def check_update(userid):
    joueur = playerlib.getPlayer(userid)
    requete = urllib2.Request("http://www.css-ressource.com/project/script_fantole/purgelog.txt")
    try:
        handle = urllib2.urlopen(requete)
    except IOError,err:
        print "[Purge Log] Erreur Check Update : %s" % err
        es.tell(userid, '#multi', '#lightgreen[Purge log]#green %s' % err)
    else:
        contenu = handle.read()
        contenu = contenu.replace('.','')
        if int(contenu) < int(version) or int(contenu) == int(version):
            es.tell(userid, '#multi', '#lightgreen[Purge log]#green %s' % messages("no_update",lang=joueur.get("lang")))
        else:
            es.tell(userid, '#multi', '#lightgreen[Purge log]#green %s' % messages("update",lang=joueur.get("lang")))
            es.tell(userid, '#multi', '#lightgreen[Purge log]#green Avant = %s  Apres = %s' % (version, contenu))
